require 'spec_helper'

describe StatisticalMethods::Computer do
  let(:delta) { 0.001 }

  context '#sum' do
    it { expect(subject.sum [0]).to be_within(delta).of(0.0) }
    it { expect(subject.sum [0, 1]).to be_within(delta).of(1.0) }
    it { expect(subject.sum [0, 1, 2]).to be_within(delta).of(3.0) }
    it { expect(subject.sum []).to be_nil }
  end

  context '#variance' do
    it { expect(subject.variance [0]).to be_within(delta).of(0.0) }
    it do
      array = [2, 4, 4, 4, 5, 5, 7, 9]
      expect(subject.variance array).to be_within(delta).of(4.0)
    end
  end

  context '#standard_deviation' do
    it { expect(subject.standard_deviation [0]).to be_within(delta).of(0.0) }
    it do
      array = [2, 4, 4, 4, 5, 5, 7, 9]
      expect(subject.standard_deviation array).to be_within(delta).of(2.0)
    end
  end
end
