require 'spec_helper'

describe StatisticalMethods::Leader do
  shared_examples_for :find do
    subject { StatisticalMethods::Leader.new(array) }
    it do
      expect(subject.find).to eq result
    end
  end

  context '#find' do
    it_behaves_like :find do
      let(:array) { [] }
      let(:result) { nil }
    end

    it_behaves_like :find do
      let(:array) { [0] }
      let(:result) { 0 }
    end

    it_behaves_like :find do
      let(:array) { [1] }
      let(:result) { 1 }
    end

    it_behaves_like :find do
      let(:array) { [0, 1] }
      let(:result) { nil }
    end

    it_behaves_like :find do
      let(:result) { rand(9) }
      let(:array) { ([result] * 5 + [0, 1, 2, 3]).shuffle }
    end
  end
end
