require 'spec_helper'

describe StatisticalMethods::SummaryStatistic::Location::Median do
  context '#median' do
    shared_examples_for :calculation do
      let(:delta) { 0.001 }
      subject { described_class.new(array) }
      it { expect(subject.find).to be_within(delta).of(result) }
    end

    it do
      subject = described_class.new([])
      expect(subject.find).to be_nil
    end

    it_behaves_like :calculation do
      let(:array) { [0] }
      let(:result) { 0.0 }
    end

    it_behaves_like :calculation do
      let(:array) { [0, 1] }
      let(:result) { 0.5 }
    end

    it_behaves_like :calculation do
      let(:array) { [0, 1, 2] }
      let(:result) { 1.0 }
    end

    it_behaves_like :calculation do
      let(:array) { [1, 2, 2, 3, 4, 6, 6, 7, 7, 7].shuffle }
      let(:result) { 5.0 }
    end
  end
end
