require 'spec_helper'

describe StatisticalMethods::SummaryStatistic::Location::Mode do
  context '#mode' do
    shared_examples_for :calculation do
      subject { described_class.new(array) }
      it { expect(subject.find).to eq(result) }
    end

    it do
      subject = described_class.new([])
      expect(subject.find).to be_nil
    end

    it_behaves_like :calculation do
      let(:array) { [0] }
      let(:result) { [0] }
    end

    it_behaves_like :calculation do
      let(:array) { [0, 0, 1] }
      let(:result) { [0] }
    end

    it_behaves_like :calculation do
      let(:array) { [0, 1, 1] }
      let(:result) { [1] }
    end

    it_behaves_like :calculation do
      let(:array) { [0, 1, 2, 1, 0] }
      let(:result) { [0, 1] }
    end
  end
end
